/*
 * TempLTSView.java
 *
 * Created on 25 July 2007, 18:04
 */

package assignment;

import javax.swing.*;
import java.awt.*;
import java.util.*;

/** This is no longer used and will be removed in a future revision.
 *
 * @author David
 */
public class TempLTSView extends LTSView {
    

    protected Graphics theSurface;
    
    private class grNode {
        public grNode(LTSNode n, int xx, int yy) {
            theNode = n;
            x = xx;
            y = yy;
        }
        public LTSNode theNode;
        public int x;
        public int y;
        
        public boolean left, right, up, down;
        
    };
    
    ArrayList<grNode> nodeList;
    
    protected int xgrpos;
    protected int ygrpos;
    protected int spacer;
    
    
    /**
     * Creates a new instance of TempLTSView
     */
    public TempLTSView() {
        theSurface = this.getGraphics();
        spacer = 100;
    }
   
    public void renderLTS() {
        theSurface = this.getGraphics();
        nodeList = new ArrayList<grNode>();
        xgrpos = 1;
        ygrpos = 1;
        
        theSurface.clearRect(0,0,this.WIDTH,this.HEIGHT);
        theSurface.drawString("LTSView Panel temporary initial implementation: Press F5 to redraw",00,20);
        
        //drawArrowLine(50,50,100,100);
        
        Collection<LTSTransition> tlist = theLTS.getTransitions();
        
        drawNode(theLTS.getStartNode(),1,1);
        
        Iterator it = tlist.iterator();
        
        while (it.hasNext()) {
            drawTransition((LTSTransition)it.next());
        }
    }
    
    protected void drawNode(LTSNode theNode, int x, int y) {
        if (theNode == null) return;
        
        int xpos = x * spacer;
        int ypos = y * spacer;
        
        theSurface.drawString(theNode.getName(),xpos,ypos);
        
        grNode tn = new grNode(theNode,xpos,ypos);
        nodeList.add(tn);
    } 
   
    protected void drawTransition(LTSTransition theTransition) {
        /* Ok, here we must draw the specified transition. Steps to victory are:
         * 1. Check if node 1 is already drawn. If not, draw it.
         * 2. Check if node 2 is already drawn. If not, draw it.
         * 3. Draw an arrow line to join the two visible nodes.
         * 4. Draw some text in the middle of the arrow line.
         */
        
        int direction = 0;
        /* Directions:
         * nothing: 0
         * up     : 1
         * right  : 2
         * down   : 3
         * left   : 4
         * center : 5   (line will start in middle of node)
         */
        
        grNode node1;
        grNode node2;
        
        // 1: Find Look for node 1
        if (!nodeExists(theTransition.getNode1())) {
            // The start node cant be found! this is odd. It should already be there.
            
            drawNode(theTransition.getNode1(),xgrpos,ygrpos);
            //xgrpos++;
            
            node1 = getNode(theTransition.getNode1());
            
            node1.right = true;   // We will join to the right.
            direction = 2;
        }
        else {
            // The node can be found. Find a place to join it.
            node1 = getNode(theTransition.getNode1());
            if (!node1.right)     { direction = 2;  node1.right = true; }
            else if (!node1.down) { direction = 3;  node1.down = true;  }
            else                { direction = 5;                    }
        }

        // 2: Find Look for node 2
        if (!nodeExists(theTransition.getNode2())) {
            // The second node cant be found. This is to be expected. Time to draw it...
            
            // Decide on a place to put the node:
            if (direction == 2) {
                // the first node is to our left. Move along to the right one.
                xgrpos++;
            }
            else if (direction == 3) {
                // The first node is above. Move down one.
                ygrpos++;
            }
            
            drawNode(theTransition.getNode2(),xgrpos,ygrpos);
            
            node2 = getNode(theTransition.getNode2());
            
            if (direction == 2) node2.left = true;
            else if (direction == 3) node2.up = true;
            
        }
        else {
            // The node can be found. Find a place to join it.
            node2 = getNode(theTransition.getNode2());
            if (direction == 2) node2.left = true;
            else if (direction == 3) node2.up = true;
        }
        
        // Ok, now draw the arrow line to connect the two nodes:
        drawArrowLine(node1.x,node1.y, node2.x, node2.y);
        
        // And lastly, draw the label for the transition
        int xp = node1.x + ((node2.x - node1.x) / 2);
        int yp = node1.y + ((node2.y - node1.y) / 2);
        theSurface.drawString(theTransition.name,xp,yp);

    }
    
    protected boolean nodeExists(LTSNode theNode) {
        for (int i = 0; i < nodeList.size(); i++)
            if (nodeList.get(i).theNode.equals(theNode))
                return true;
        return false;
    }
    
    protected grNode getNode(LTSNode theNode) {
        for (int i = 0; i < nodeList.size(); i++)
            if (nodeList.get(i).theNode.equals(theNode))
                return nodeList.get(i);
        return null;
    }
    
    protected void drawArrowLine(int x1, int y1, int x2, int y2) {
        // First up, draw the line
        theSurface.drawLine(x1,y1,x2,y2);
        theSurface.drawRect(x2-5,y2-5,5,5);
    }   
}
