/*
 * graphVector.java
 *
 * Created on 1 August 2007, 18:05
 */

package assignment;

/**
 *
 * @author David
 */
public class graphVector {
    /* Components of the Vector: */
    public double x;
    public double y;
    
    /** Constructs a new graphVector
     */
    public graphVector(double x, double y) {
        this.x = x;
        this.y = y;
    }
    /** Calculates the length of the vector
     */
    public double length() {
        return Math.sqrt(Math.pow(x,2) + Math.pow(y,2));
    }
    
    /** Calculates the unit of the vector
     */
    public graphVector getUnit() {
        graphVector unit = new graphVector(0,0);
        double v = 1.0 / length();

        unit.x = x * v;
        unit.y = y * v;
        return unit;
    }
    
    /** Calculates the Normal of the vector
     */
    public graphVector getNormal() {
        return new graphVector(-y,x);
    }
    
    /** Adds two vectors
     */
    public static graphVector add(graphVector a, graphVector b) {
        return new graphVector(a.x + b.x, a.y + b.y);
    }
    
    /** Adds the given vector to this one.
     */
    public void add(graphVector a) {
        x += a.x;
        y += a.y;
    }
    
    /** Adds a value to both components of the vector
     */
    public static graphVector add(graphVector a, double v) {
        return new graphVector(a.x + v, a.y + v);
    }
    
    /** Subtracts one vector from another and returns the result
     */
    public static graphVector subtract(graphVector a, graphVector b) {
        return new graphVector(a.x - b.x, a.y - b.y);
    }
    
    /** Subtracts the given vector from this one.
     */
    public void subtract (graphVector a) {
        x -= a.x;
        y -= a.y;
    }
    
    /** Scalar Multiplys the given vector by the given value and returns the result
     */
    public static graphVector scalarMultiply(graphVector a, double v) {
        return new graphVector(a.x * v, a.y * v);
    }
    
    /** Adds a value to both components of the vector
     */
    public void scalarMultiply(double v) {
        x = x*v;
        y = y*v;
    }
    
    /** Returns a string representation of the vector
     */
    public String toString() {
        return "(" + x + "," + y + ")";
    }
}
